Index: manager.c
===================================================================
--- manager.c	(revision 45797)
+++ manager.c	(working copy)
@@ -382,6 +382,23 @@
 		ast_cli(s->fd, "\r\n");
 }
 
+void astman_send_response_uniqueid(struct mansession *s, struct message *m, char *resp, char *msg, char *uniqueid);
+
+void astman_send_response_uniqueid(struct mansession *s, struct message *m, char *resp, char *msg, char *uniqueid)
+{
+	char *id = astman_get_header(m,"ActionID");
+
+	ast_cli(s->fd, "Response: %s\r\n", resp);
+	if (!ast_strlen_zero(id))
+		ast_cli(s->fd, "ActionID: %s\r\n",id);
+	if (!ast_strlen_zero(uniqueid))
+		ast_cli(s->fd, "Uniqueid: %s\r\n", uniqueid);
+	if (msg)
+		ast_cli(s->fd, "Message: %s\r\n\r\n", msg);
+	else
+		ast_cli(s->fd, "\r\n");
+}
+
 void astman_send_ack(struct mansession *s, struct message *m, char *msg)
 {
 	astman_send_response(s, m, "Success", msg);
@@ -1005,6 +1022,7 @@
 	char *async = astman_get_header(m, "Async");
 	char *id = astman_get_header(m, "ActionID");
 	struct ast_variable *vars = astman_get_variables(m);
+	struct ast_channel *chan = NULL;
 	char *tech, *data;
 	char *l=NULL, *n=NULL;
 	int pi = 0;
@@ -1079,19 +1097,24 @@
 			}
 		}
 	} else if (!ast_strlen_zero(app)) {
-        	res = ast_pbx_outgoing_app(tech, AST_FORMAT_SLINEAR, data, to, app, appdata, &reason, 1, l, n, vars, account, NULL);
+        	res = ast_pbx_outgoing_app(tech, AST_FORMAT_SLINEAR, data, to, app, appdata, &reason, 1, l, n, vars, account, &chan);
     	} else {
 		if (exten && context && pi)
-	        	res = ast_pbx_outgoing_exten(tech, AST_FORMAT_SLINEAR, data, to, context, exten, pi, &reason, 1, l, n, vars, account, NULL);
+	        	res = ast_pbx_outgoing_exten(tech, AST_FORMAT_SLINEAR, data, to, context, exten, pi, &reason, 1, l, n, vars, account, &chan);
 		else {
 			astman_send_error(s, m, "Originate with 'Exten' requires 'Context' and 'Priority'");
 			return 0;
 		}
 	}   
-	if (!res)
-		astman_send_ack(s, m, "Originate successfully queued");
-	else
+	if (!res) {
+		if (chan && chan->uniqueid[0]) {
+			astman_send_response_uniqueid(s, m, "Success", "Originate successfully queued", chan->uniqueid);
+		} else  {
+			astman_send_ack(s, m, "Originate successfully queued");
+		}
+	} else {
 		astman_send_error(s, m, "Originate failed");
+	}
 	return 0;
 }
 
